package dialog;
import tm2.*;

import java.awt.*;
import mdgawt.*;
import java.awt.event.*;

public class GridSizeDialog extends Dialog implements WindowListener,
                                                      ActionListener{
      public TMG tmg;
      public UpDownCounter vert;
   public GridSizeDialog(TMG t){
      super(t.myFrame,"Grid Size",true);
      tmg=t;
      setSize(150,100);
      setResizable(false);
      Point pl = tmg.myFrame.getLocation();
      setLocation(pl.x+100,pl.y+100);
      setLayout(new GridLayout(2,1,4,4));
      Panel p1 = new Panel();
         vert   = new UpDownCounter(8,200);
         vert.setValue(tmg.getGridSize());
         p1.add(vert);
         add(p1);
      Panel p2 = new Panel();
         Button b = new Button("Ok");
         b.addActionListener(this);
         p2.add(b);
         Button bb = new Button("Cancel");
         bb.addActionListener(this);
         p2.add(bb);
         add(p2);
      setVisible(true);
      addWindowListener(this);
}
   public void actionPerformed(ActionEvent e){
      Object c = e.getSource();
      if (c instanceof Button){
         String command = ((Button)c).getLabel();
         if(command.equals("Ok")){
            tmg.setGridSize(vert.getValue());
            tmg.repaintAllGraphs();dispose();}
         else if(command.equals("Cancel"))dispose();
      }
   }
//-----------------------------Events--------------------------------         
   public void windowOpened(WindowEvent e){}
   public void windowClosing(WindowEvent e){dispose();}
   public void windowClosed(WindowEvent e){}
   public void windowIconified(WindowEvent e){}
   public void windowDeiconified(WindowEvent e){}
   public void windowActivated(WindowEvent e){}
   public void windowDeactivated(WindowEvent e){}
}




