package dialog;
import tm2.*;
import java.awt.*;
import mdgawt.*;
import java.awt.event.*;

public class StateDialog extends Dialog implements ActionListener{
      TextArea ta;
      TMG tmg;
      State st;
   public StateDialog(TMG t, State s){
      super(t.myFrame,"State",true);
      st=s;tmg=t;
      setSize(300,130);
      setResizable(false);
      Point p1 = tmg.getLocation();
      Point p2 = st.getLocation();
      setLocation(p1.x+p2.x,p1.y+p2.y);
      setLayout(new BorderLayout());
      ta = new TextArea(s.getText(),40,3);
      add("Center",ta);
      Panel p = new Panel();
      Button b = new Button("Ok");
      b.addActionListener(this);
      p.add(b);
      b = new Button("Cancel");
      b.addActionListener(this);
      p.add(b);
      add("South",p);}
   public void actionPerformed(ActionEvent e){
       Object c = e.getSource();
       if (c instanceof Button){
         String command = ((Button)c).getLabel();
         if(command.equals("Ok")){
            st.setText(ta.getText());
            tmg.fullRepaint();
            dispose();}
         else if(command.equals("Cancel"))dispose();
      }
   }
}




