
package mdgawt;

import java.awt.*;

public class UCS extends MyComponent implements Runnable{
// --------------------------INSTANCE DATA-----------------------------------
   protected Thread tt        = null;
   protected boolean isRunning = false;
   protected boolean toggle = false;
   protected boolean hasBeenEdited = true;
   protected int lineHeight = 0;
// ---------------------------CONSTRUCTOR------------------------------------
   public UCS(){
      super("Construction Zone",0,0);
      setSize(200,24);
      setBackground(Color.yellow);start();}
// -------------------------------RUN----------------------------------------
   public void start(){
      if(isRunning)return;
      tt = new Thread(this);
      tt.start();}
   public void stop(){isRunning = false;}
   public void run(){
      isRunning = true;
      while(isRunning){
         toggle= !toggle;
         if(parent!=null)paint(parent.getGraphics());
         try{Thread.sleep(50);}
            catch(InterruptedException e){}
      }
   }
//-------------------------------PAINT---------------------------------------
   public void setSize(int w,int h){
      super.setSize(w,h+h%2);
      hasBeenEdited = true;}
   public static final int MAX_PHASE = 20;
   public Image[] buffer = new Image[MAX_PHASE];
   public void createBuffers(){
      if(parent==null){hasBeenEdited=true;return;}
      Image c = parent.createImage(10,10);
      Graphics cg=c.getGraphics();
      cg.setFont(new Font("Courier",Font.BOLD,20));
      fm = cg.getFontMetrics();
      lineHeight = fm.getHeight();
      int w = fm.stringWidth(getText())+100;
      int h = fm.getHeight();
      for(int j=0;j<MAX_PHASE;j++){
         if(buffer[j]!=null)buffer[j].flush();
         buffer[j]=parent.createImage(w,h);
         Graphics bg=buffer[j].getGraphics();
         bg.setFont(new Font("Courier",Font.BOLD,20));
         bg.setColor(Color.black);
         bg.fillRect(1,1,w,h-2);
         bg.setColor(Color.yellow);
         bg.drawRect(0,0,w-1,h-1);
         bg.drawString(getText(),50,(5*lineHeight)/6-1);
         bg.setXORMode(Color.yellow);
         int h2 = h/2;
         for(int i=-h2;i<w+h2;i++){
            if((i+h2+MAX_PHASE-phase)%MAX_PHASE>=MAX_PHASE/2)
               bg.setColor(Color.yellow);
            else bg.setColor(Color.black);
            bg.drawLine(i,0,i+h2-1,h2-1);
            bg.drawLine(i,h-1,i+h2,h2);}
         phase++;
         phase=phase%MAX_PHASE;
         bg.dispose();
      }
      super.setSize(w,h);  
      hasBeenEdited = false;
   }
   public synchronized void update(Graphics g){paint(g);}
   public int phase = 0;
   FontMetrics fm;
   public synchronized void paint(Graphics g) {
      if(!isVisible() || g==null)return;
      if(hasBeenEdited)createBuffers();
      Point p = getLocation();
      g.translate(p.x,p.y);
      g.drawImage(buffer[phase],0,0,parent);
      g.translate(-p.x,-p.y);
      phase++;
      phase=phase%MAX_PHASE;}
   public String toString(){return "<UCS>";}
}  


   /*   bg.setColor(Color.black);
      bg.fillRect(1,1,d.width-2,d.height-2);
      bg.setColor(Color.yellow);
      bg.drawRect(0,0,d.width-1,d.height-1);
      bg.drawString(getText(),3,(5*lineHeight)/6-1);
      bg.setXORMode(Color.yellow);
      for(int i=-d.height/2;i<d.width+d.height;i++){
         if((i+(MAX_PHASE-phase))%MAX_PHASE>MAX_PHASE/2)
            bg.setColor(Color.yellow);
         else bg.setColor(Color.black);
         bg.drawLine(i,0,i+d.height/2-1,d.height/2-1);
         bg.drawLine(i,d.height,i+d.height/2,d.height/2);}*/


/*
   public synchronized void paint(Graphics g) {
      if(g==null)return;
      setup();
      Point p = getLocation();
      Dimension d = getSize();
      if(toggle)g.setColor(Color.yellow);
      else g.setColor(Color.black);
      g.fillRect(p.x+1,p.y+1,d.width-2,d.height-2);
      if(toggle)g.setColor(Color.black);
      else g.setColor(Color.yellow);
      g.drawRect(p.x+0,p.y+0,d.width-1,d.height-1);
      g.drawString(getText(),p.x+3,p.y+(5*lineHeight)/6);
      g.setXORMode(Color.yellow);
      for(int i=phase;i<d.width+d.height;i++){
         if(i%6==0){
            g.setColor(Color.yellow);
            g.drawLine(p.x+i,p.y,p.x-d.height+i,p.y+d.height);}
         if(i%12==0){
            g.setColor(Color.black);
            g.drawLine(p.x+i,p.y,p.x-d.height+i,p.y+d.height);}
      g.setPaintMode();
      hasBeenEdited = false;
      phase++;
      phase=phase%MAX_PHASE;
   }

*/
